/*
 * This file generated automatically from xcb.m4 by macros-xcb.m4 using m4.
 * Edit at your peril.
 */

#ifndef __XCB_H
#define __XCB_H
#include <X11/XCB/xcb_trace.h>


#include <X11/XCB/xcb_conn.h>

/* Core event and error types */

#define XCBKeyPress 2

#define XCBKeyRelease 3

#define XCBButtonPress 4

#define XCBButtonRelease 5

#define XCBMotionNotify 6

#define XCBEnterNotify 7

#define XCBLeaveNotify 8

#define XCBFocusIn 9

#define XCBFocusOut 10

#define XCBKeymapNotify 11

#define XCBExpose 12

#define XCBGraphicsExposure 13

#define XCBNoExposure 14

#define XCBVisibilityNotify 15

#define XCBCreateNotify 16

#define XCBDestroyNotify 17

#define XCBUnmapNotify 18

#define XCBMapNotify 19

#define XCBMapRequest 20

#define XCBReparentNotify 21

#define XCBConfigureNotify 22

#define XCBConfigureRequest 23

#define XCBGravityNotify 24

#define XCBResizeRequest 25

#define XCBCirculateNotify 26

#define XCBCirculateRequest 27

#define XCBPropertyNotify 28

#define XCBSelectionClear 29

#define XCBSelectionRequest 30

#define XCBSelectionNotify 31

#define XCBColormapNotify 32

#define XCBClientMessage 33

#define XCBMappingNotify 34

#define XCBRequest 1

#define XCBValue 2

#define XCBWindow 3

#define XCBPixmap 4

#define XCBAtom 5

#define XCBCursor 6

#define XCBFont 7

#define XCBMatch 8

#define XCBDrawable 9

#define XCBAccess 10

#define XCBAlloc 11

#define XCBColormap 12

#define XCBGContext 13

#define XCBIDChoice 14

#define XCBName 15

#define XCBLength 16

#define XCBImplementation 17


/* The requests, in major number order. */
/* It is the caller's responsibility to free returned XCB*Rep objects. */

/* The ListFontsWithInfo request is not supported by XCB. */


typedef struct XCBKeyPressEvent {
    BYTE response_type;
    KEYCODE detail;
    CARD16 seqnum;
    TIMESTAMP time;
    WINDOW root;
    WINDOW event;
    WINDOW child;
    INT16 root_x;
    INT16 root_y;
    INT16 event_x;
    INT16 event_y;
    CARD16 state;
    BOOL same_screen;
} XCBKeyPressEvent;

typedef XCBKeyPressEvent XCBKeyReleaseEvent;
typedef struct XCBButtonPressEvent {
    BYTE response_type;
    BUTTON detail;
    CARD16 seqnum;
    TIMESTAMP time;
    WINDOW root;
    WINDOW event;
    WINDOW child;
    INT16 root_x;
    INT16 root_y;
    INT16 event_x;
    INT16 event_y;
    CARD16 state;
    BOOL same_screen;
} XCBButtonPressEvent;

typedef XCBButtonPressEvent XCBButtonReleaseEvent;
typedef struct XCBMotionNotifyEvent {
    BYTE response_type;
    BYTE detail;
    CARD16 seqnum;
    TIMESTAMP time;
    WINDOW root;
    WINDOW event;
    WINDOW child;
    INT16 root_x;
    INT16 root_y;
    INT16 event_x;
    INT16 event_y;
    CARD16 state;
    BOOL same_screen;
} XCBMotionNotifyEvent;

typedef struct XCBEnterNotifyEvent {
    BYTE response_type;
    BYTE detail;
    CARD16 seqnum;
    TIMESTAMP time;
    WINDOW root;
    WINDOW event;
    WINDOW child;
    INT16 root_x;
    INT16 root_y;
    INT16 event_x;
    INT16 event_y;
    CARD16 state;
    BYTE mode;
    BYTE same_screen_focus;
} XCBEnterNotifyEvent;

typedef XCBEnterNotifyEvent XCBLeaveNotifyEvent;
typedef struct XCBFocusInEvent {
    BYTE response_type;
    BYTE detail;
    CARD16 seqnum;
    WINDOW event;
    BYTE mode;
} XCBFocusInEvent;

typedef XCBFocusInEvent XCBFocusOutEvent;
typedef struct XCBKeymapNotifyEvent {
    BYTE response_type;
    CARD8 keys[31];
} XCBKeymapNotifyEvent;

typedef struct XCBExposeEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    WINDOW window;
    CARD16 x;
    CARD16 y;
    CARD16 width;
    CARD16 height;
    CARD16 count;
} XCBExposeEvent;

typedef struct XCBGraphicsExposureEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    DRAWABLE drawable;
    CARD16 x;
    CARD16 y;
    CARD16 width;
    CARD16 height;
    CARD16 minor_opcode;
    CARD16 count;
    CARD8 major_opcode;
} XCBGraphicsExposureEvent;

typedef struct XCBNoExposureEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    DRAWABLE drawable;
    CARD16 minor_opcode;
    CARD8 major_opcode;
} XCBNoExposureEvent;

typedef struct XCBVisibilityNotifyEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    WINDOW window;
    BYTE state;
} XCBVisibilityNotifyEvent;

typedef struct XCBCreateNotifyEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    WINDOW parent;
    WINDOW window;
    INT16 x;
    INT16 y;
    CARD16 width;
    CARD16 height;
    CARD16 border_width;
    BOOL override_redirect;
} XCBCreateNotifyEvent;

typedef struct XCBDestroyNotifyEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    WINDOW event;
    WINDOW window;
} XCBDestroyNotifyEvent;

typedef struct XCBUnmapNotifyEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    WINDOW event;
    WINDOW window;
    BOOL from_configure;
} XCBUnmapNotifyEvent;

typedef struct XCBMapNotifyEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    WINDOW event;
    WINDOW window;
    BOOL override_redirect;
} XCBMapNotifyEvent;

typedef struct XCBMapRequestEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    WINDOW parent;
    WINDOW window;
} XCBMapRequestEvent;

typedef struct XCBReparentNotifyEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    WINDOW event;
    WINDOW window;
    WINDOW parent;
    INT16 x;
    INT16 y;
    BOOL override_redirect;
} XCBReparentNotifyEvent;

typedef struct XCBConfigureNotifyEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    WINDOW event;
    WINDOW window;
    WINDOW above_sibling;
    INT16 x;
    INT16 y;
    CARD16 width;
    CARD16 height;
    CARD16 border_width;
    BOOL override_redirect;
} XCBConfigureNotifyEvent;

typedef struct XCBConfigureRequestEvent {
    BYTE response_type;
    BYTE stack_mode;
    CARD16 seqnum;
    WINDOW parent;
    WINDOW window;
    WINDOW sibling;
    INT16 x;
    INT16 y;
    CARD16 width;
    CARD16 height;
    CARD16 border_width;
    CARD16 value_mask;
} XCBConfigureRequestEvent;

typedef struct XCBGravityNotifyEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    WINDOW event;
    WINDOW window;
    INT16 x;
    INT16 y;
} XCBGravityNotifyEvent;

typedef struct XCBResizeRequestEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    WINDOW window;
    CARD16 width;
    CARD16 height;
} XCBResizeRequestEvent;

typedef struct XCBCirculateNotifyEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    WINDOW event;
    WINDOW window;
    CARD8 pad1[4];
    BYTE place;
} XCBCirculateNotifyEvent;

typedef XCBCirculateNotifyEvent XCBCirculateRequestEvent;
typedef struct XCBPropertyNotifyEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    WINDOW window;
    ATOM atom;
    TIMESTAMP time;
    BYTE state;
} XCBPropertyNotifyEvent;

typedef struct XCBSelectionClearEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    TIMESTAMP time;
    WINDOW owner;
    ATOM selection;
} XCBSelectionClearEvent;

typedef struct XCBSelectionRequestEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    TIMESTAMP time;
    WINDOW owner;
    WINDOW requestor;
    ATOM selection;
    ATOM target;
    ATOM property;
} XCBSelectionRequestEvent;

typedef struct XCBSelectionNotifyEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    TIMESTAMP time;
    WINDOW requestor;
    ATOM selection;
    ATOM target;
    ATOM property;
} XCBSelectionNotifyEvent;

typedef struct XCBColormapNotifyEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    WINDOW window;
    COLORMAP colormap;
    BOOL _new;
    BYTE state;
} XCBColormapNotifyEvent;

typedef struct XCBClientMessageEvent {
    BYTE response_type;
    CARD8 format;
    CARD16 seqnum;
    WINDOW window;
    ATOM type;
} XCBClientMessageEvent;

typedef struct XCBMappingNotifyEvent {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    BYTE request;
    KEYCODE first_keycode;
    CARD8 count;
} XCBMappingNotifyEvent;

typedef struct XCBRequestError {
    BYTE response_type;
    BYTE error_code;
    CARD16 seqnum;
    CARD32 bad_value;
    CARD16 minor_opcode;
    CARD8 major_opcode;
} XCBRequestError;

typedef struct XCBValueError {
    BYTE response_type;
    BYTE error_code;
    CARD16 seqnum;
    CARD32 bad_value;
    CARD16 minor_opcode;
    CARD8 major_opcode;
} XCBValueError;

typedef XCBValueError XCBWindowError;
typedef XCBValueError XCBPixmapError;
typedef XCBValueError XCBAtomError;
typedef XCBValueError XCBCursorError;
typedef XCBValueError XCBFontError;
typedef XCBRequestError XCBMatchError;
typedef XCBValueError XCBDrawableError;
typedef XCBRequestError XCBAccessError;
typedef XCBRequestError XCBAllocError;
typedef XCBValueError XCBColormapError;
typedef XCBValueError XCBGContextError;
typedef XCBValueError XCBIDChoiceError;
typedef XCBRequestError XCBNameError;
typedef XCBRequestError XCBLengthError;
typedef XCBRequestError XCBImplementationError;
typedef enum XCBCW {
    XCBCWBackPixmap = 1L<<0,
    XCBCWBackPixel = 1L<<1,
    XCBCWBorderPixmap = 1L<<2,
    XCBCWBorderPixel = 1L<<3,
    XCBCWBitGravity = 1L<<4,
    XCBCWWinGravity = 1L<<5,
    XCBCWBackingStore = 1L<<6,
    XCBCWBackingPlanes = 1L<<7,
    XCBCWBackingPixel = 1L<<8,
    XCBCWOverrideRedirect = 1L<<9,
    XCBCWSaveUnder = 1L<<10,
    XCBCWEventMask = 1L<<11,
    XCBCWDontPropagate = 1L<<12,
    XCBCWColormap = 1L<<13,
    XCBCWCursor = 1L<<14,
} XCBCW;
typedef struct XCBCreateWindowReq {
    CARD8 major_opcode;
    CARD8 depth;
    CARD16 length;
    WINDOW wid;
    WINDOW parent;
    INT16 x;
    INT16 y;
    CARD16 width;
    CARD16 height;
    CARD16 border_width;
    CARD16 class;
    VISUALID visual;
    CARD32 value_mask;
} XCBCreateWindowReq;

typedef struct XCBChangeWindowAttributesReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW window;
    CARD32 value_mask;
} XCBChangeWindowAttributesReq;

typedef struct XCBGetWindowAttributesCookie {
    int seqnum;
} XCBGetWindowAttributesCookie;
typedef struct XCBGetWindowAttributesReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW window;
} XCBGetWindowAttributesReq;

typedef struct XCBGetWindowAttributesRep {
    BYTE response_type;
    CARD8 backing_store;
    CARD16 seqnum;
    CARD32 length;
    VISUALID visual;
    CARD16 _class;
    CARD8 bit_gravity;
    CARD8 win_gravity;
    CARD32 backing_planes;
    CARD32 backing_pixel;
    BOOL save_under;
    BOOL map_is_installed;
    CARD8 map_state;
    BOOL override_redirect;
    COLORMAP colormap;
    CARD32 all_event_masks;
    CARD32 your_event_mask;
    CARD16 do_not_propagate_mask;
} XCBGetWindowAttributesRep;

typedef struct XCBDestroyWindowReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW window;
} XCBDestroyWindowReq;

typedef struct XCBDestroySubwindowsReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW window;
} XCBDestroySubwindowsReq;

typedef struct XCBChangeSaveSetReq {
    CARD8 major_opcode;
    BYTE mode;
    CARD16 length;
    WINDOW window;
} XCBChangeSaveSetReq;

typedef struct XCBReparentWindowReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW window;
    WINDOW parent;
    INT16 x;
    INT16 y;
} XCBReparentWindowReq;

typedef struct XCBMapWindowReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW window;
} XCBMapWindowReq;

typedef struct XCBMapSubwindowsReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW window;
} XCBMapSubwindowsReq;

typedef struct XCBUnmapWindowReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW window;
} XCBUnmapWindowReq;

typedef struct XCBUnmapSubwindowsReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW window;
} XCBUnmapSubwindowsReq;

typedef struct XCBConfigureWindowReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW window;
    CARD16 value_mask;
} XCBConfigureWindowReq;

typedef struct XCBCirculateWindowReq {
    CARD8 major_opcode;
    CARD8 direction;
    CARD16 length;
    WINDOW window;
} XCBCirculateWindowReq;

typedef struct XCBGetGeometryCookie {
    int seqnum;
} XCBGetGeometryCookie;
typedef struct XCBGetGeometryReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    DRAWABLE drawable;
} XCBGetGeometryReq;

typedef struct XCBGetGeometryRep {
    BYTE response_type;
    CARD8 depth;
    CARD16 seqnum;
    CARD32 length;
    WINDOW root;
    INT16 x;
    INT16 y;
    CARD16 width;
    CARD16 height;
    CARD16 border_width;
} XCBGetGeometryRep;

typedef struct XCBQueryTreeCookie {
    int seqnum;
} XCBQueryTreeCookie;
typedef struct XCBQueryTreeReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW window;
} XCBQueryTreeReq;

typedef struct XCBQueryTreeRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    WINDOW root;
    WINDOW parent;
    CARD16 children_len;
    CARD8 pad1[14];
} XCBQueryTreeRep;

typedef struct XCBInternAtomCookie {
    int seqnum;
} XCBInternAtomCookie;
typedef struct XCBInternAtomReq {
    CARD8 major_opcode;
    BOOL only_if_exists;
    CARD16 length;
    CARD16 name_len;
    CARD8 pad0[2];
} XCBInternAtomReq;

typedef struct XCBInternAtomRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    ATOM atom;
} XCBInternAtomRep;

typedef struct XCBGetAtomNameCookie {
    int seqnum;
} XCBGetAtomNameCookie;
typedef struct XCBGetAtomNameReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    ATOM atom;
} XCBGetAtomNameReq;

typedef struct XCBGetAtomNameRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    CARD16 name_len;
    CARD8 pad1[22];
} XCBGetAtomNameRep;

typedef struct XCBChangePropertyReq {
    CARD8 major_opcode;
    CARD8 mode;
    CARD16 length;
    WINDOW window;
    ATOM property;
    ATOM type;
    CARD8 format;
    CARD8 pad0[3];
    CARD32 data_len;
} XCBChangePropertyReq;

typedef struct XCBDeletePropertyReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW window;
    ATOM property;
} XCBDeletePropertyReq;

typedef struct XCBGetPropertyCookie {
    int seqnum;
} XCBGetPropertyCookie;
typedef struct XCBGetPropertyReq {
    CARD8 major_opcode;
    BOOL delete;
    CARD16 length;
    WINDOW window;
    ATOM property;
    ATOM type;
    CARD32 long_offset;
    CARD32 long_length;
} XCBGetPropertyReq;

typedef struct XCBGetPropertyRep {
    BYTE response_type;
    CARD8 format;
    CARD16 seqnum;
    CARD32 length;
    ATOM type;
    CARD32 bytes_after;
    CARD32 value_len;
    CARD8 pad0[12];
} XCBGetPropertyRep;

typedef struct XCBListPropertiesCookie {
    int seqnum;
} XCBListPropertiesCookie;
typedef struct XCBListPropertiesReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW window;
} XCBListPropertiesReq;

typedef struct XCBListPropertiesRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    CARD16 atoms_len;
    CARD8 pad1[22];
} XCBListPropertiesRep;

typedef struct XCBSetSelectionOwnerReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW owner;
    ATOM selection;
    TIMESTAMP time;
} XCBSetSelectionOwnerReq;

typedef struct XCBGetSelectionOwnerCookie {
    int seqnum;
} XCBGetSelectionOwnerCookie;
typedef struct XCBGetSelectionOwnerReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    ATOM selection;
} XCBGetSelectionOwnerReq;

typedef struct XCBGetSelectionOwnerRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    WINDOW owner;
} XCBGetSelectionOwnerRep;

typedef struct XCBConvertSelectionReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW requestor;
    ATOM selection;
    ATOM target;
    ATOM property;
    TIMESTAMP time;
} XCBConvertSelectionReq;

typedef struct XCBSendEventReq {
    CARD8 major_opcode;
    BOOL propagate;
    CARD16 length;
    WINDOW destination;
    CARD32 event_mask;
} XCBSendEventReq;

typedef struct XCBGrabPointerCookie {
    int seqnum;
} XCBGrabPointerCookie;
typedef struct XCBGrabPointerReq {
    CARD8 major_opcode;
    BOOL owner_events;
    CARD16 length;
    WINDOW grab_window;
    CARD16 event_mask;
    BYTE pointer_mode;
    BYTE keyboard_mode;
    WINDOW confine_to;
    CURSOR cursor;
    TIMESTAMP time;
} XCBGrabPointerReq;

typedef struct XCBGrabPointerRep {
    BYTE response_type;
    BYTE status;
    CARD16 seqnum;
    CARD32 length;
} XCBGrabPointerRep;

typedef struct XCBUngrabPointerReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    TIMESTAMP time;
} XCBUngrabPointerReq;

typedef struct XCBGrabButtonReq {
    CARD8 major_opcode;
    BOOL owner_events;
    CARD16 length;
    WINDOW grab_window;
    CARD16 event_mask;
    CARD8 pointer_mode;
    CARD8 keyboard_mode;
    WINDOW confine_to;
    CURSOR cursor;
    CARD8 button;
    CARD8 pad0;
    CARD16 modifiers;
} XCBGrabButtonReq;

typedef struct XCBUngrabButtonReq {
    CARD8 major_opcode;
    CARD8 button;
    CARD16 length;
    WINDOW grab_window;
    CARD16 modifiers;
    CARD8 pad0[2];
} XCBUngrabButtonReq;

typedef struct XCBChangeActivePointerGrabReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    CURSOR cursor;
    TIMESTAMP time;
    CARD16 event_mask;
} XCBChangeActivePointerGrabReq;

typedef struct XCBGrabKeyboardCookie {
    int seqnum;
} XCBGrabKeyboardCookie;
typedef struct XCBGrabKeyboardReq {
    CARD8 major_opcode;
    BOOL owner_events;
    CARD16 length;
    WINDOW grab_window;
    TIMESTAMP time;
    BYTE pointer_mode;
    BYTE keyboard_mode;
} XCBGrabKeyboardReq;

typedef struct XCBGrabKeyboardRep {
    BYTE response_type;
    BYTE status;
    CARD16 seqnum;
    CARD32 length;
} XCBGrabKeyboardRep;

typedef struct XCBUngrabKeyboardReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    TIMESTAMP time;
} XCBUngrabKeyboardReq;

typedef struct XCBGrabKeyReq {
    CARD8 major_opcode;
    BOOL owner_events;
    CARD16 length;
    WINDOW grab_window;
    CARD16 modifiers;
    KEYCODE key;
    CARD8 pointer_mode;
    CARD8 keyboard_mode;
} XCBGrabKeyReq;

typedef struct XCBUngrabKeyReq {
    CARD8 major_opcode;
    CARD8 key;
    CARD16 length;
    WINDOW grab_window;
    CARD16 modifiers;
} XCBUngrabKeyReq;

typedef struct XCBAllowEventsReq {
    CARD8 major_opcode;
    CARD8 mode;
    CARD16 length;
    TIMESTAMP time;
} XCBAllowEventsReq;

typedef struct XCBGrabServerReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
} XCBGrabServerReq;

typedef struct XCBUngrabServerReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
} XCBUngrabServerReq;

typedef struct XCBQueryPointerCookie {
    int seqnum;
} XCBQueryPointerCookie;
typedef struct XCBQueryPointerReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW window;
} XCBQueryPointerReq;

typedef struct XCBQueryPointerRep {
    BYTE response_type;
    BOOL same_screen;
    CARD16 seqnum;
    CARD32 length;
    WINDOW root;
    WINDOW child;
    INT16 root_x;
    INT16 root_y;
    INT16 win_x;
    INT16 win_y;
    CARD16 mask;
} XCBQueryPointerRep;

typedef struct TIMECOORD {
    TIMESTAMP time;
    INT16 x;
    INT16 y;
} TIMECOORD;

typedef struct TIMECOORDIter {
    TIMECOORD *data;
    int rem;
} TIMECOORDIter;

typedef struct XCBGetMotionEventsCookie {
    int seqnum;
} XCBGetMotionEventsCookie;
typedef struct XCBGetMotionEventsReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW window;
    TIMESTAMP start;
    TIMESTAMP stop;
} XCBGetMotionEventsReq;

typedef struct XCBGetMotionEventsRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    CARD32 events_len;
    CARD8 pad1[20];
} XCBGetMotionEventsRep;

typedef struct XCBTranslateCoordinatesCookie {
    int seqnum;
} XCBTranslateCoordinatesCookie;
typedef struct XCBTranslateCoordinatesReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW src_window;
    WINDOW dst_window;
    INT16 src_x;
    INT16 src_y;
} XCBTranslateCoordinatesReq;

typedef struct XCBTranslateCoordinatesRep {
    BYTE response_type;
    BOOL same_screen;
    CARD16 seqnum;
    CARD32 length;
    WINDOW child;
    CARD16 dst_x;
    CARD16 dst_y;
} XCBTranslateCoordinatesRep;

typedef struct XCBWarpPointerReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW src_window;
    WINDOW dst_window;
    INT16 src_x;
    INT16 src_y;
    CARD16 src_width;
    CARD16 src_height;
    INT16 dst_x;
    INT16 dst_y;
} XCBWarpPointerReq;

typedef struct XCBSetInputFocusReq {
    CARD8 major_opcode;
    CARD8 revert_to;
    CARD16 length;
    WINDOW focus;
    TIMESTAMP time;
} XCBSetInputFocusReq;

typedef struct XCBGetInputFocusCookie {
    int seqnum;
} XCBGetInputFocusCookie;
typedef struct XCBGetInputFocusReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
} XCBGetInputFocusReq;

typedef struct XCBGetInputFocusRep {
    BYTE response_type;
    CARD8 revert_to;
    CARD16 seqnum;
    CARD32 length;
    WINDOW focus;
} XCBGetInputFocusRep;

typedef struct XCBQueryKeymapCookie {
    int seqnum;
} XCBQueryKeymapCookie;
typedef struct XCBQueryKeymapReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
} XCBQueryKeymapReq;

typedef struct XCBQueryKeymapRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    CARD8 keys[32];
} XCBQueryKeymapRep;

typedef struct XCBOpenFontReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    FONT fid;
    CARD16 name_len;
} XCBOpenFontReq;

typedef struct XCBCloseFontReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    FONT font;
} XCBCloseFontReq;

typedef struct FONTPROP {
    ATOM name;
    CARD32 value;
} FONTPROP;

typedef struct FONTPROPIter {
    FONTPROP *data;
    int rem;
} FONTPROPIter;

typedef struct CHARINFO {
    INT16 left_side_bearing;
    INT16 right_side_bearing;
    INT16 character_width;
    INT16 ascent;
    INT16 descent;
    CARD16 attributes;
} CHARINFO;

typedef struct CHARINFOIter {
    CHARINFO *data;
    int rem;
} CHARINFOIter;

typedef struct XCBQueryFontCookie {
    int seqnum;
} XCBQueryFontCookie;
typedef struct XCBQueryFontReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    FONTABLE font;
} XCBQueryFontReq;

typedef struct XCBQueryFontRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    CHARINFO min_bounds;
    CARD8 pad1[4];
    CHARINFO max_bounds;
    CARD8 pad2[4];
    CARD16 min_char_or_byte2;
    CARD16 max_char_or_byte2;
    CARD16 default_char;
    CARD16 properties_len;
    BYTE draw_direction;
    CARD8 min_byte1;
    CARD8 max_byte1;
    BOOL all_chars_exist;
    INT16 font_ascent;
    INT16 font_descent;
    CARD32 char_infos_len;
} XCBQueryFontRep;

typedef struct XCBQueryTextExtentsCookie {
    int seqnum;
} XCBQueryTextExtentsCookie;
typedef struct XCBQueryTextExtentsReq {
    CARD8 major_opcode;
    BOOL odd_length;
    CARD16 length;
    FONTABLE font;
} XCBQueryTextExtentsReq;

typedef struct XCBQueryTextExtentsRep {
    BYTE response_type;
    BYTE draw_direction;
    CARD16 seqnum;
    CARD32 length;
    INT16 font_ascent;
    INT16 font_descent;
    INT16 overall_ascent;
    INT16 overall_descent;
    INT32 overall_width;
    INT32 overall_left;
    INT32 overall_right;
} XCBQueryTextExtentsRep;

typedef struct STR {
    CARD8 name_len;
} STR;

typedef struct STRIter {
    STR *data;
    int rem;
} STRIter;

typedef struct XCBListFontsCookie {
    int seqnum;
} XCBListFontsCookie;
typedef struct XCBListFontsReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    CARD16 max_names;
    CARD16 pattern_len;
} XCBListFontsReq;

typedef struct XCBListFontsRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    CARD16 names_len;
    CARD8 pad1[22];
} XCBListFontsRep;

typedef struct XCBSetFontPathReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    CARD16 font_qty;
} XCBSetFontPathReq;

typedef struct XCBGetFontPathCookie {
    int seqnum;
} XCBGetFontPathCookie;
typedef struct XCBGetFontPathReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
} XCBGetFontPathReq;

typedef struct XCBGetFontPathRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    CARD16 path_len;
    CARD8 pad1[22];
} XCBGetFontPathRep;

typedef struct XCBCreatePixmapReq {
    CARD8 major_opcode;
    CARD8 depth;
    CARD16 length;
    PIXMAP pid;
    DRAWABLE drawable;
    CARD16 width;
    CARD16 height;
} XCBCreatePixmapReq;

typedef struct XCBFreePixmapReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    PIXMAP pixmap;
} XCBFreePixmapReq;

typedef struct XCBCreateGCReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    GCONTEXT cid;
    DRAWABLE drawable;
    CARD32 value_mask;
} XCBCreateGCReq;

typedef struct XCBChangeGCReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    GCONTEXT gc;
    CARD32 value_mask;
} XCBChangeGCReq;

typedef struct XCBCopyGCReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    GCONTEXT src_gc;
    GCONTEXT dst_gc;
    CARD32 value_mask;
} XCBCopyGCReq;

typedef struct XCBSetDashesReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    GCONTEXT gc;
    CARD16 dash_offset;
    CARD16 dashes_len;
} XCBSetDashesReq;

typedef struct XCBSetClipRectanglesReq {
    CARD8 major_opcode;
    BYTE ordering;
    CARD16 length;
    GCONTEXT gc;
    INT16 clip_x_origin;
    INT16 clip_y_origin;
} XCBSetClipRectanglesReq;

typedef struct XCBFreeGCReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    GCONTEXT gc;
} XCBFreeGCReq;

typedef struct XCBClearAreaReq {
    CARD8 major_opcode;
    BOOL exposures;
    CARD16 length;
    WINDOW window;
    INT16 x;
    INT16 y;
    CARD16 width;
    CARD16 height;
} XCBClearAreaReq;

typedef struct XCBCopyAreaReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    DRAWABLE src_drawable;
    DRAWABLE dst_drawable;
    GCONTEXT gc;
    INT16 src_x;
    INT16 src_y;
    INT16 dst_x;
    INT16 dst_y;
    CARD16 width;
    CARD16 height;
} XCBCopyAreaReq;

typedef struct XCBCopyPlaneReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    DRAWABLE src_drawable;
    DRAWABLE dst_drawable;
    GCONTEXT gc;
    INT16 src_x;
    INT16 src_y;
    INT16 dst_x;
    INT16 dst_y;
    CARD16 width;
    CARD16 height;
    CARD32 bit_plane;
} XCBCopyPlaneReq;

typedef struct XCBPolyPointReq {
    CARD8 major_opcode;
    BYTE coordinate_mode;
    CARD16 length;
    DRAWABLE drawable;
    GCONTEXT gc;
} XCBPolyPointReq;

typedef struct XCBPolyLineReq {
    CARD8 major_opcode;
    BYTE coordinate_mode;
    CARD16 length;
    DRAWABLE drawable;
    GCONTEXT gc;
} XCBPolyLineReq;

typedef struct SEGMENT {
    INT16 x1;
    INT16 y1;
    INT16 x2;
    INT16 y2;
} SEGMENT;

typedef struct SEGMENTIter {
    SEGMENT *data;
    int rem;
} SEGMENTIter;

typedef struct XCBPolySegmentReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    DRAWABLE drawable;
    GCONTEXT gc;
} XCBPolySegmentReq;

typedef struct XCBPolyRectangleReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    DRAWABLE drawable;
    GCONTEXT gc;
} XCBPolyRectangleReq;

typedef struct XCBPolyArcReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    DRAWABLE drawable;
    GCONTEXT gc;
} XCBPolyArcReq;

typedef struct XCBFillPolyReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    DRAWABLE drawable;
    GCONTEXT gc;
    CARD8 shape;
    CARD8 coordinate_mode;
} XCBFillPolyReq;

typedef struct XCBPolyFillRectangleReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    DRAWABLE drawable;
    GCONTEXT gc;
} XCBPolyFillRectangleReq;

typedef struct XCBPolyFillArcReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    DRAWABLE drawable;
    GCONTEXT gc;
} XCBPolyFillArcReq;

typedef struct XCBPutImageReq {
    CARD8 major_opcode;
    CARD8 format;
    CARD16 length;
    DRAWABLE drawable;
    GCONTEXT gc;
    CARD16 width;
    CARD16 height;
    INT16 dst_x;
    INT16 dst_y;
    CARD8 left_pad;
    CARD8 depth;
} XCBPutImageReq;

typedef struct XCBGetImageCookie {
    int seqnum;
} XCBGetImageCookie;
typedef struct XCBGetImageReq {
    CARD8 major_opcode;
    CARD8 format;
    CARD16 length;
    DRAWABLE drawable;
    INT16 x;
    INT16 y;
    CARD16 width;
    CARD16 height;
    CARD32 plane_mask;
} XCBGetImageReq;

typedef struct XCBGetImageRep {
    BYTE response_type;
    CARD8 depth;
    CARD16 seqnum;
    CARD32 length;
    VISUALID visual;
    CARD8 pad0[20];
} XCBGetImageRep;

typedef struct XCBPolyText8Req {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    DRAWABLE drawable;
    GCONTEXT gc;
    INT16 x;
    INT16 y;
} XCBPolyText8Req;

typedef struct XCBPolyText16Req {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    DRAWABLE drawable;
    GCONTEXT gc;
    INT16 x;
    INT16 y;
} XCBPolyText16Req;

typedef struct XCBImageText8Req {
    CARD8 major_opcode;
    BYTE string_len;
    CARD16 length;
    DRAWABLE drawable;
    GCONTEXT gc;
    INT16 x;
    INT16 y;
} XCBImageText8Req;

typedef struct XCBImageText16Req {
    CARD8 major_opcode;
    BYTE string_len;
    CARD16 length;
    DRAWABLE drawable;
    GCONTEXT gc;
    INT16 x;
    INT16 y;
} XCBImageText16Req;

typedef struct XCBCreateColormapReq {
    CARD8 major_opcode;
    BYTE alloc;
    CARD16 length;
    COLORMAP mid;
    WINDOW window;
    VISUALID visual;
} XCBCreateColormapReq;

typedef struct XCBFreeColormapReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    COLORMAP cmap;
} XCBFreeColormapReq;

typedef struct XCBCopyColormapAndFreeReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    COLORMAP mid;
    COLORMAP src_cmap;
} XCBCopyColormapAndFreeReq;

typedef struct XCBInstallColormapReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    COLORMAP cmap;
} XCBInstallColormapReq;

typedef struct XCBUninstallColormapReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    COLORMAP cmap;
} XCBUninstallColormapReq;

typedef struct XCBListInstalledColormapsCookie {
    int seqnum;
} XCBListInstalledColormapsCookie;
typedef struct XCBListInstalledColormapsReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    WINDOW window;
} XCBListInstalledColormapsReq;

typedef struct XCBListInstalledColormapsRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    CARD16 cmaps_len;
    CARD8 pad1[22];
} XCBListInstalledColormapsRep;

typedef struct XCBAllocColorCookie {
    int seqnum;
} XCBAllocColorCookie;
typedef struct XCBAllocColorReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    COLORMAP cmap;
    CARD16 red;
    CARD16 green;
    CARD16 blue;
} XCBAllocColorReq;

typedef struct XCBAllocColorRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    CARD16 red;
    CARD16 green;
    CARD16 blue;
    CARD8 pad1[2];
    CARD32 pixel;
} XCBAllocColorRep;

typedef struct XCBAllocNamedColorCookie {
    int seqnum;
} XCBAllocNamedColorCookie;
typedef struct XCBAllocNamedColorReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    COLORMAP cmap;
    CARD16 name_len;
} XCBAllocNamedColorReq;

typedef struct XCBAllocNamedColorRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    CARD32 pixel;
    CARD16 exact_red;
    CARD16 exact_green;
    CARD16 exact_blue;
    CARD16 visual_red;
    CARD16 visual_green;
    CARD16 visual_blue;
} XCBAllocNamedColorRep;

typedef struct XCBAllocColorCellsCookie {
    int seqnum;
} XCBAllocColorCellsCookie;
typedef struct XCBAllocColorCellsReq {
    CARD8 major_opcode;
    BOOL contiguous;
    CARD16 length;
    COLORMAP cmap;
    CARD16 colors;
    CARD16 planes;
} XCBAllocColorCellsReq;

typedef struct XCBAllocColorCellsRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    CARD16 pixels_len;
    CARD16 masks_len;
    CARD8 pad1[20];
} XCBAllocColorCellsRep;

typedef struct XCBAllocColorPlanesCookie {
    int seqnum;
} XCBAllocColorPlanesCookie;
typedef struct XCBAllocColorPlanesReq {
    CARD8 major_opcode;
    BOOL contiguous;
    CARD16 length;
    COLORMAP cmap;
    CARD16 colors;
    CARD16 reds;
    CARD16 greens;
    CARD16 blues;
} XCBAllocColorPlanesReq;

typedef struct XCBAllocColorPlanesRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    CARD16 pixels_len;
    CARD8 pad1[2];
    CARD32 red_mask;
    CARD32 green_mask;
    CARD32 blue_mask;
    CARD8 pad2[8];
} XCBAllocColorPlanesRep;

typedef struct XCBFreeColorsReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    COLORMAP cmap;
    CARD32 plane_mask;
} XCBFreeColorsReq;

typedef struct COLORITEM {
    CARD32 pixel;
    CARD16 red;
    CARD16 green;
    CARD16 blue;
    BYTE flags;
    CARD8 pad0;
} COLORITEM;

typedef struct COLORITEMIter {
    COLORITEM *data;
    int rem;
} COLORITEMIter;

typedef struct XCBStoreColorsReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    COLORMAP cmap;
} XCBStoreColorsReq;

typedef struct XCBStoreNamedColorReq {
    CARD8 major_opcode;
    CARD8 flags;
    CARD16 length;
    COLORMAP cmap;
    CARD32 pixel;
    CARD16 name_len;
} XCBStoreNamedColorReq;

typedef struct RGB {
    CARD16 red;
    CARD16 green;
    CARD16 blue;
    CARD8 pad0[2];
} RGB;

typedef struct RGBIter {
    RGB *data;
    int rem;
} RGBIter;

typedef struct XCBQueryColorsCookie {
    int seqnum;
} XCBQueryColorsCookie;
typedef struct XCBQueryColorsReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    COLORMAP cmap;
} XCBQueryColorsReq;

typedef struct XCBQueryColorsRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    CARD16 colors_len;
    CARD8 pad1[22];
} XCBQueryColorsRep;

typedef struct XCBLookupColorCookie {
    int seqnum;
} XCBLookupColorCookie;
typedef struct XCBLookupColorReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    COLORMAP cmap;
    CARD16 name_len;
} XCBLookupColorReq;

typedef struct XCBLookupColorRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    CARD16 exact_red;
    CARD16 exact_green;
    CARD16 exact_blue;
    CARD16 visual_red;
    CARD16 visual_green;
    CARD16 visual_blue;
} XCBLookupColorRep;

typedef struct XCBCreateCursorReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    CURSOR cid;
    PIXMAP source;
    PIXMAP mask;
    CARD16 fore_red;
    CARD16 fore_green;
    CARD16 fore_blue;
    CARD16 back_red;
    CARD16 back_green;
    CARD16 back_blue;
    CARD16 x;
    CARD16 y;
} XCBCreateCursorReq;

typedef struct XCBCreateGlyphCursorReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    CURSOR cid;
    FONT source_font;
    FONT mask_font;
    CARD16 source_char;
    CARD16 mask_char;
    CARD16 fore_red;
    CARD16 fore_green;
    CARD16 fore_blue;
    CARD16 back_red;
    CARD16 back_green;
    CARD16 back_blue;
} XCBCreateGlyphCursorReq;

typedef struct XCBFreeCursorReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    CURSOR cursor;
} XCBFreeCursorReq;

typedef struct XCBRecolorCursorReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    CURSOR cursor;
    CARD16 fore_red;
    CARD16 fore_green;
    CARD16 fore_blue;
    CARD16 back_red;
    CARD16 back_green;
    CARD16 back_blue;
} XCBRecolorCursorReq;

typedef struct XCBQueryBestSizeCookie {
    int seqnum;
} XCBQueryBestSizeCookie;
typedef struct XCBQueryBestSizeReq {
    CARD8 major_opcode;
    CARD8 class;
    CARD16 length;
    DRAWABLE drawable;
    CARD16 width;
    CARD16 height;
} XCBQueryBestSizeReq;

typedef struct XCBQueryBestSizeRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    CARD16 width;
    CARD16 height;
} XCBQueryBestSizeRep;

typedef struct XCBQueryExtensionCookie {
    int seqnum;
} XCBQueryExtensionCookie;
typedef struct XCBQueryExtensionReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    CARD16 name_len;
} XCBQueryExtensionReq;

typedef struct XCBQueryExtensionRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    BOOL present;
    CARD8 major_opcode;
    CARD8 first_event;
    CARD8 first_error;
} XCBQueryExtensionRep;

typedef struct XCBListExtensionsCookie {
    int seqnum;
} XCBListExtensionsCookie;
typedef struct XCBListExtensionsReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
} XCBListExtensionsReq;

typedef struct XCBListExtensionsRep {
    BYTE response_type;
    CARD8 names_len;
    CARD16 seqnum;
    CARD32 length;
    CARD8 pad0[24];
} XCBListExtensionsRep;

typedef struct XCBChangeKeyboardMappingReq {
    CARD8 major_opcode;
    CARD8 keycode_count;
    CARD16 length;
    KEYCODE first_keycode;
    CARD8 keysyms_per_keycode;
} XCBChangeKeyboardMappingReq;

typedef struct XCBGetKeyboardMappingCookie {
    int seqnum;
} XCBGetKeyboardMappingCookie;
typedef struct XCBGetKeyboardMappingReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    KEYCODE first_keycode;
    CARD8 count;
} XCBGetKeyboardMappingReq;

typedef struct XCBGetKeyboardMappingRep {
    BYTE response_type;
    BYTE keysyms_per_keycode;
    CARD16 seqnum;
    CARD32 length;
    CARD8 pad0[24];
} XCBGetKeyboardMappingRep;

typedef struct XCBChangeKeyboardControlReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    CARD32 value_mask;
} XCBChangeKeyboardControlReq;

typedef struct XCBGetKeyboardControlCookie {
    int seqnum;
} XCBGetKeyboardControlCookie;
typedef struct XCBGetKeyboardControlReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
} XCBGetKeyboardControlReq;

typedef struct XCBGetKeyboardControlRep {
    BYTE response_type;
    BYTE global_auto_repeat;
    CARD16 seqnum;
    CARD32 length;
    CARD32 led_mask;
    CARD8 key_click_percent;
    CARD8 bell_percent;
    CARD16 bell_pitch;
    CARD16 bell_duration;
    CARD8 pad0[2];
    CARD8 auto_repeats[32];
} XCBGetKeyboardControlRep;

typedef struct XCBBellReq {
    CARD8 major_opcode;
    INT8 percent;
    CARD16 length;
} XCBBellReq;

typedef struct XCBChangePointerControlReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    INT16 acceleration_numerator;
    INT16 acceleration_denominator;
    INT16 threshold;
    BOOL do_acceleration;
    BOOL do_threshold;
} XCBChangePointerControlReq;

typedef struct XCBGetPointerControlCookie {
    int seqnum;
} XCBGetPointerControlCookie;
typedef struct XCBGetPointerControlReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
} XCBGetPointerControlReq;

typedef struct XCBGetPointerControlRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    CARD16 acceleration_numerator;
    CARD16 acceleration_denominator;
    CARD16 threshold;
} XCBGetPointerControlRep;

typedef struct XCBSetScreenSaverReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    INT16 timeout;
    INT16 interval;
    CARD8 prefer_blanking;
    CARD8 allow_exposures;
} XCBSetScreenSaverReq;

typedef struct XCBGetScreenSaverCookie {
    int seqnum;
} XCBGetScreenSaverCookie;
typedef struct XCBGetScreenSaverReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
} XCBGetScreenSaverReq;

typedef struct XCBGetScreenSaverRep {
    BYTE response_type;
    CARD8 pad0;
    CARD16 seqnum;
    CARD32 length;
    CARD16 timeout;
    CARD16 interval;
    BYTE prefer_blanking;
    BYTE allow_exposures;
} XCBGetScreenSaverRep;

typedef struct XCBChangeHostsReq {
    CARD8 major_opcode;
    CARD8 mode;
    CARD16 length;
    CARD8 family;
    CARD8 pad0;
    CARD16 address_len;
} XCBChangeHostsReq;

typedef struct HOST {
    CARD8 family;
    CARD8 pad0;
    CARD16 address_len;
} HOST;

typedef struct HOSTIter {
    HOST *data;
    int rem;
} HOSTIter;

typedef struct XCBListHostsCookie {
    int seqnum;
} XCBListHostsCookie;
typedef struct XCBListHostsReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
} XCBListHostsReq;

typedef struct XCBListHostsRep {
    BYTE response_type;
    BYTE mode;
    CARD16 seqnum;
    CARD32 length;
    CARD16 hosts_len;
    CARD8 pad0[22];
} XCBListHostsRep;

typedef struct XCBSetAccessControlReq {
    CARD8 major_opcode;
    CARD8 mode;
    CARD16 length;
} XCBSetAccessControlReq;

typedef struct XCBSetCloseDownModeReq {
    CARD8 major_opcode;
    CARD8 mode;
    CARD16 length;
} XCBSetCloseDownModeReq;

typedef struct XCBKillClientReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
    CARD32 resource;
} XCBKillClientReq;

typedef struct XCBRotatePropertiesReq {
    CARD8 major_opcode;
    WINDOW window;
    CARD16 length;
    CARD16 atoms_len;
    INT16 delta;
} XCBRotatePropertiesReq;

typedef struct XCBForceScreenSaverReq {
    CARD8 major_opcode;
    CARD8 mode;
    CARD16 length;
} XCBForceScreenSaverReq;

typedef struct XCBSetPointerMappingCookie {
    int seqnum;
} XCBSetPointerMappingCookie;
typedef struct XCBSetPointerMappingReq {
    CARD8 major_opcode;
    CARD8 map_len;
    CARD16 length;
} XCBSetPointerMappingReq;

typedef struct XCBSetPointerMappingRep {
    BYTE response_type;
    BYTE status;
    CARD16 seqnum;
    CARD32 length;
} XCBSetPointerMappingRep;

typedef struct XCBGetPointerMappingCookie {
    int seqnum;
} XCBGetPointerMappingCookie;
typedef struct XCBGetPointerMappingReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
} XCBGetPointerMappingReq;

typedef struct XCBGetPointerMappingRep {
    BYTE response_type;
    CARD8 map_len;
    CARD16 seqnum;
    CARD32 length;
    CARD8 pad0[24];
} XCBGetPointerMappingRep;

typedef struct XCBSetModifierMappingCookie {
    int seqnum;
} XCBSetModifierMappingCookie;
typedef struct XCBSetModifierMappingReq {
    CARD8 major_opcode;
    CARD8 keycodes_per_modifier;
    CARD16 length;
} XCBSetModifierMappingReq;

typedef struct XCBSetModifierMappingRep {
    BYTE response_type;
    BYTE status;
    CARD16 seqnum;
    CARD32 length;
} XCBSetModifierMappingRep;

typedef struct XCBGetModifierMappingCookie {
    int seqnum;
} XCBGetModifierMappingCookie;
typedef struct XCBGetModifierMappingReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
} XCBGetModifierMappingReq;

typedef struct XCBGetModifierMappingRep {
    BYTE response_type;
    CARD8 keycodes_per_modifier;
    CARD16 seqnum;
    CARD32 length;
    CARD8 pad0[24];
} XCBGetModifierMappingRep;

typedef struct XCBNoOperationReq {
    CARD8 major_opcode;
    CARD8 pad0;
    CARD16 length;
} XCBNoOperationReq;

XCBVoidCookie XCBCreateWindow(XCBConnection *c, CARD8 depth, WINDOW wid, WINDOW parent, INT16 x, INT16 y, CARD16 width, CARD16 height, CARD16 border_width, CARD16 class, VISUALID visual, CARD32 value_mask, const CARD32 *value_list);
XCBVoidCookie XCBChangeWindowAttributes(XCBConnection *c, WINDOW window, CARD32 value_mask, const CARD32 *value_list);
XCBGetWindowAttributesCookie XCBGetWindowAttributes(XCBConnection *c, WINDOW window);
XCBVoidCookie XCBDestroyWindow(XCBConnection *c, WINDOW window);
XCBVoidCookie XCBDestroySubwindows(XCBConnection *c, WINDOW window);
XCBVoidCookie XCBChangeSaveSet(XCBConnection *c, BYTE mode, WINDOW window);
XCBVoidCookie XCBReparentWindow(XCBConnection *c, WINDOW window, WINDOW parent, INT16 x, INT16 y);
XCBVoidCookie XCBMapWindow(XCBConnection *c, WINDOW window);
XCBVoidCookie XCBMapSubwindows(XCBConnection *c, WINDOW window);
XCBVoidCookie XCBUnmapWindow(XCBConnection *c, WINDOW window);
XCBVoidCookie XCBUnmapSubwindows(XCBConnection *c, WINDOW window);
XCBVoidCookie XCBConfigureWindow(XCBConnection *c, WINDOW window, CARD16 value_mask, const CARD32 *value_list);
XCBVoidCookie XCBCirculateWindow(XCBConnection *c, CARD8 direction, WINDOW window);
XCBGetGeometryCookie XCBGetGeometry(XCBConnection *c, DRAWABLE drawable);
XCBQueryTreeCookie XCBQueryTree(XCBConnection *c, WINDOW window);
XCBInternAtomCookie XCBInternAtom(XCBConnection *c, BOOL only_if_exists, CARD16 name_len, const char *name);
XCBGetAtomNameCookie XCBGetAtomName(XCBConnection *c, ATOM atom);
XCBVoidCookie XCBChangeProperty(XCBConnection *c, CARD8 mode, WINDOW window, ATOM property, ATOM type, CARD8 format, CARD32 data_len, const void *data);
XCBVoidCookie XCBDeleteProperty(XCBConnection *c, WINDOW window, ATOM property);
XCBGetPropertyCookie XCBGetProperty(XCBConnection *c, BOOL delete, WINDOW window, ATOM property, ATOM type, CARD32 long_offset, CARD32 long_length);
XCBListPropertiesCookie XCBListProperties(XCBConnection *c, WINDOW window);
XCBVoidCookie XCBSetSelectionOwner(XCBConnection *c, WINDOW owner, ATOM selection, TIMESTAMP time);
XCBGetSelectionOwnerCookie XCBGetSelectionOwner(XCBConnection *c, ATOM selection);
XCBVoidCookie XCBConvertSelection(XCBConnection *c, WINDOW requestor, ATOM selection, ATOM target, ATOM property, TIMESTAMP time);
XCBVoidCookie XCBSendEvent(XCBConnection *c, BOOL propagate, WINDOW destination, CARD32 event_mask, const char *event);
XCBGrabPointerCookie XCBGrabPointer(XCBConnection *c, BOOL owner_events, WINDOW grab_window, CARD16 event_mask, BYTE pointer_mode, BYTE keyboard_mode, WINDOW confine_to, CURSOR cursor, TIMESTAMP time);
XCBVoidCookie XCBUngrabPointer(XCBConnection *c, TIMESTAMP time);
XCBVoidCookie XCBGrabButton(XCBConnection *c, BOOL owner_events, WINDOW grab_window, CARD16 event_mask, CARD8 pointer_mode, CARD8 keyboard_mode, WINDOW confine_to, CURSOR cursor, CARD8 button, CARD16 modifiers);
XCBVoidCookie XCBUngrabButton(XCBConnection *c, CARD8 button, WINDOW grab_window, CARD16 modifiers);
XCBVoidCookie XCBChangeActivePointerGrab(XCBConnection *c, CURSOR cursor, TIMESTAMP time, CARD16 event_mask);
XCBGrabKeyboardCookie XCBGrabKeyboard(XCBConnection *c, BOOL owner_events, WINDOW grab_window, TIMESTAMP time, BYTE pointer_mode, BYTE keyboard_mode);
XCBVoidCookie XCBUngrabKeyboard(XCBConnection *c, TIMESTAMP time);
XCBVoidCookie XCBGrabKey(XCBConnection *c, BOOL owner_events, WINDOW grab_window, CARD16 modifiers, KEYCODE key, CARD8 pointer_mode, CARD8 keyboard_mode);
XCBVoidCookie XCBUngrabKey(XCBConnection *c, CARD8 key, WINDOW grab_window, CARD16 modifiers);
XCBVoidCookie XCBAllowEvents(XCBConnection *c, CARD8 mode, TIMESTAMP time);
XCBVoidCookie XCBGrabServer(XCBConnection *c);
XCBVoidCookie XCBUngrabServer(XCBConnection *c);
XCBQueryPointerCookie XCBQueryPointer(XCBConnection *c, WINDOW window);
void *TIMECOORDAfterIter(TIMECOORDIter i);
XCBGetMotionEventsCookie XCBGetMotionEvents(XCBConnection *c, WINDOW window, TIMESTAMP start, TIMESTAMP stop);
XCBTranslateCoordinatesCookie XCBTranslateCoordinates(XCBConnection *c, WINDOW src_window, WINDOW dst_window, INT16 src_x, INT16 src_y);
XCBVoidCookie XCBWarpPointer(XCBConnection *c, WINDOW src_window, WINDOW dst_window, INT16 src_x, INT16 src_y, CARD16 src_width, CARD16 src_height, INT16 dst_x, INT16 dst_y);
XCBVoidCookie XCBSetInputFocus(XCBConnection *c, CARD8 revert_to, WINDOW focus, TIMESTAMP time);
XCBGetInputFocusCookie XCBGetInputFocus(XCBConnection *c);
XCBQueryKeymapCookie XCBQueryKeymap(XCBConnection *c);
XCBVoidCookie XCBOpenFont(XCBConnection *c, FONT fid, CARD16 name_len, const char *name);
XCBVoidCookie XCBCloseFont(XCBConnection *c, FONT font);
void *FONTPROPAfterIter(FONTPROPIter i);
void *CHARINFOAfterIter(CHARINFOIter i);
XCBQueryFontCookie XCBQueryFont(XCBConnection *c, FONTABLE font);
XCBQueryTextExtentsCookie XCBQueryTextExtents(XCBConnection *c, FONTABLE font, CARD16 string_len, const CHAR2B *string);
void *STRAfterIter(STRIter i);
XCBListFontsCookie XCBListFonts(XCBConnection *c, CARD16 max_names, CARD16 pattern_len, const char *pattern);
STRIter XCBListFontsnames(XCBListFontsRep *R);
XCBVoidCookie XCBSetFontPath(XCBConnection *c, CARD16 font_qty, CARD16 path_len, const char *path);
XCBGetFontPathCookie XCBGetFontPath(XCBConnection *c);
STRIter XCBGetFontPathpath(XCBGetFontPathRep *R);
XCBVoidCookie XCBCreatePixmap(XCBConnection *c, CARD8 depth, PIXMAP pid, DRAWABLE drawable, CARD16 width, CARD16 height);
XCBVoidCookie XCBFreePixmap(XCBConnection *c, PIXMAP pixmap);
XCBVoidCookie XCBCreateGC(XCBConnection *c, GCONTEXT cid, DRAWABLE drawable, CARD32 value_mask, const CARD32 *value_list);
XCBVoidCookie XCBChangeGC(XCBConnection *c, GCONTEXT gc, CARD32 value_mask, const CARD32 *value_list);
XCBVoidCookie XCBCopyGC(XCBConnection *c, GCONTEXT src_gc, GCONTEXT dst_gc, CARD32 value_mask);
XCBVoidCookie XCBSetDashes(XCBConnection *c, GCONTEXT gc, CARD16 dash_offset, CARD16 dashes_len, const CARD8 *dashes);
XCBVoidCookie XCBSetClipRectangles(XCBConnection *c, BYTE ordering, GCONTEXT gc, INT16 clip_x_origin, INT16 clip_y_origin, CARD16 rectangles_len, const RECTANGLE *rectangles);
XCBVoidCookie XCBFreeGC(XCBConnection *c, GCONTEXT gc);
XCBVoidCookie XCBClearArea(XCBConnection *c, BOOL exposures, WINDOW window, INT16 x, INT16 y, CARD16 width, CARD16 height);
XCBVoidCookie XCBCopyArea(XCBConnection *c, DRAWABLE src_drawable, DRAWABLE dst_drawable, GCONTEXT gc, INT16 src_x, INT16 src_y, INT16 dst_x, INT16 dst_y, CARD16 width, CARD16 height);
XCBVoidCookie XCBCopyPlane(XCBConnection *c, DRAWABLE src_drawable, DRAWABLE dst_drawable, GCONTEXT gc, INT16 src_x, INT16 src_y, INT16 dst_x, INT16 dst_y, CARD16 width, CARD16 height, CARD32 bit_plane);
XCBVoidCookie XCBPolyPoint(XCBConnection *c, BYTE coordinate_mode, DRAWABLE drawable, GCONTEXT gc, CARD16 points_len, const POINT *points);
XCBVoidCookie XCBPolyLine(XCBConnection *c, BYTE coordinate_mode, DRAWABLE drawable, GCONTEXT gc, CARD16 points_len, const POINT *points);
void *SEGMENTAfterIter(SEGMENTIter i);
XCBVoidCookie XCBPolySegment(XCBConnection *c, DRAWABLE drawable, GCONTEXT gc, CARD16 segments_len, const SEGMENT *segments);
XCBVoidCookie XCBPolyRectangle(XCBConnection *c, DRAWABLE drawable, GCONTEXT gc, CARD16 rectangles_len, const RECTANGLE *rectangles);
XCBVoidCookie XCBPolyArc(XCBConnection *c, DRAWABLE drawable, GCONTEXT gc, CARD16 arcs_len, const ARC *arcs);
XCBVoidCookie XCBFillPoly(XCBConnection *c, DRAWABLE drawable, GCONTEXT gc, CARD8 shape, CARD8 coordinate_mode, CARD16 points_len, const POINT *points);
XCBVoidCookie XCBPolyFillRectangle(XCBConnection *c, DRAWABLE drawable, GCONTEXT gc, CARD16 rectangles_len, const RECTANGLE *rectangles);
XCBVoidCookie XCBPolyFillArc(XCBConnection *c, DRAWABLE drawable, GCONTEXT gc, CARD16 arcs_len, const ARC *arcs);
XCBVoidCookie XCBPutImage(XCBConnection *c, CARD8 format, DRAWABLE drawable, GCONTEXT gc, CARD16 width, CARD16 height, INT16 dst_x, INT16 dst_y, CARD8 left_pad, CARD8 depth, CARD16 data_len, const BYTE *data);
XCBGetImageCookie XCBGetImage(XCBConnection *c, CARD8 format, DRAWABLE drawable, INT16 x, INT16 y, CARD16 width, CARD16 height, CARD32 plane_mask);
XCBVoidCookie XCBPolyText8(XCBConnection *c, DRAWABLE drawable, GCONTEXT gc, INT16 x, INT16 y, CARD16 items_len, const BYTE *items);
XCBVoidCookie XCBPolyText16(XCBConnection *c, DRAWABLE drawable, GCONTEXT gc, INT16 x, INT16 y, CARD16 items_len, const BYTE *items);
XCBVoidCookie XCBImageText8(XCBConnection *c, BYTE string_len, DRAWABLE drawable, GCONTEXT gc, INT16 x, INT16 y, const char *string);
XCBVoidCookie XCBImageText16(XCBConnection *c, BYTE string_len, DRAWABLE drawable, GCONTEXT gc, INT16 x, INT16 y, const CHAR2B *string);
XCBVoidCookie XCBCreateColormap(XCBConnection *c, BYTE alloc, COLORMAP mid, WINDOW window, VISUALID visual);
XCBVoidCookie XCBFreeColormap(XCBConnection *c, COLORMAP cmap);
XCBVoidCookie XCBCopyColormapAndFree(XCBConnection *c, COLORMAP mid, COLORMAP src_cmap);
XCBVoidCookie XCBInstallColormap(XCBConnection *c, COLORMAP cmap);
XCBVoidCookie XCBUninstallColormap(XCBConnection *c, COLORMAP cmap);
XCBListInstalledColormapsCookie XCBListInstalledColormaps(XCBConnection *c, WINDOW window);
XCBAllocColorCookie XCBAllocColor(XCBConnection *c, COLORMAP cmap, CARD16 red, CARD16 green, CARD16 blue);
XCBAllocNamedColorCookie XCBAllocNamedColor(XCBConnection *c, COLORMAP cmap, CARD16 name_len, const char *name);
XCBAllocColorCellsCookie XCBAllocColorCells(XCBConnection *c, BOOL contiguous, COLORMAP cmap, CARD16 colors, CARD16 planes);
XCBAllocColorPlanesCookie XCBAllocColorPlanes(XCBConnection *c, BOOL contiguous, COLORMAP cmap, CARD16 colors, CARD16 reds, CARD16 greens, CARD16 blues);
XCBVoidCookie XCBFreeColors(XCBConnection *c, COLORMAP cmap, CARD32 plane_mask, CARD16 pixels_len, const CARD32 *pixels);
void *COLORITEMAfterIter(COLORITEMIter i);
XCBVoidCookie XCBStoreColors(XCBConnection *c, COLORMAP cmap, CARD16 items_len, const COLORITEM *items);
XCBVoidCookie XCBStoreNamedColor(XCBConnection *c, CARD8 flags, COLORMAP cmap, CARD32 pixel, CARD16 name_len, const char *name);
void *RGBAfterIter(RGBIter i);
XCBQueryColorsCookie XCBQueryColors(XCBConnection *c, COLORMAP cmap, CARD16 pixels_len, const CARD32 *pixels);
XCBLookupColorCookie XCBLookupColor(XCBConnection *c, COLORMAP cmap, CARD16 name_len, const char *name);
XCBVoidCookie XCBCreateCursor(XCBConnection *c, CURSOR cid, PIXMAP source, PIXMAP mask, CARD16 fore_red, CARD16 fore_green, CARD16 fore_blue, CARD16 back_red, CARD16 back_green, CARD16 back_blue, CARD16 x, CARD16 y);
XCBVoidCookie XCBCreateGlyphCursor(XCBConnection *c, CURSOR cid, FONT source_font, FONT mask_font, CARD16 source_char, CARD16 mask_char, CARD16 fore_red, CARD16 fore_green, CARD16 fore_blue, CARD16 back_red, CARD16 back_green, CARD16 back_blue);
XCBVoidCookie XCBFreeCursor(XCBConnection *c, CURSOR cursor);
XCBVoidCookie XCBRecolorCursor(XCBConnection *c, CURSOR cursor, CARD16 fore_red, CARD16 fore_green, CARD16 fore_blue, CARD16 back_red, CARD16 back_green, CARD16 back_blue);
XCBQueryBestSizeCookie XCBQueryBestSize(XCBConnection *c, CARD8 class, DRAWABLE drawable, CARD16 width, CARD16 height);
XCBQueryExtensionCookie XCBQueryExtension(XCBConnection *c, CARD16 name_len, const char *name);
XCBListExtensionsCookie XCBListExtensions(XCBConnection *c);
STRIter XCBListExtensionsnames(XCBListExtensionsRep *R);
XCBVoidCookie XCBChangeKeyboardMapping(XCBConnection *c, CARD8 keycode_count, KEYCODE first_keycode, CARD8 keysyms_per_keycode, const KEYSYM *keysyms);
XCBGetKeyboardMappingCookie XCBGetKeyboardMapping(XCBConnection *c, KEYCODE first_keycode, CARD8 count);
XCBVoidCookie XCBChangeKeyboardControl(XCBConnection *c, CARD32 value_mask, const CARD32 *value_list);
XCBGetKeyboardControlCookie XCBGetKeyboardControl(XCBConnection *c);
XCBVoidCookie XCBBell(XCBConnection *c, INT8 percent);
XCBVoidCookie XCBChangePointerControl(XCBConnection *c, INT16 acceleration_numerator, INT16 acceleration_denominator, INT16 threshold, BOOL do_acceleration, BOOL do_threshold);
XCBGetPointerControlCookie XCBGetPointerControl(XCBConnection *c);
XCBVoidCookie XCBSetScreenSaver(XCBConnection *c, INT16 timeout, INT16 interval, CARD8 prefer_blanking, CARD8 allow_exposures);
XCBGetScreenSaverCookie XCBGetScreenSaver(XCBConnection *c);
XCBVoidCookie XCBChangeHosts(XCBConnection *c, CARD8 mode, CARD8 family, CARD16 address_len, const char *address);
void *HOSTAfterIter(HOSTIter i);
XCBListHostsCookie XCBListHosts(XCBConnection *c);
HOSTIter XCBListHostshosts(XCBListHostsRep *R);
XCBVoidCookie XCBSetAccessControl(XCBConnection *c, CARD8 mode);
XCBVoidCookie XCBSetCloseDownMode(XCBConnection *c, CARD8 mode);
XCBVoidCookie XCBKillClient(XCBConnection *c, CARD32 resource);
XCBVoidCookie XCBRotateProperties(XCBConnection *c, WINDOW window, CARD16 atoms_len, INT16 delta, const ATOM *atoms);
XCBVoidCookie XCBForceScreenSaver(XCBConnection *c, CARD8 mode);
XCBSetPointerMappingCookie XCBSetPointerMapping(XCBConnection *c, CARD8 map_len, const CARD8 *map);
XCBGetPointerMappingCookie XCBGetPointerMapping(XCBConnection *c);
XCBSetModifierMappingCookie XCBSetModifierMapping(XCBConnection *c, CARD8 keycodes_per_modifier, const KEYCODE *keycodes);
XCBGetModifierMappingCookie XCBGetModifierMapping(XCBConnection *c);
XCBVoidCookie XCBNoOperation(XCBConnection *c);
int XCBSync(XCBConnection *c, XCBGenericEvent **e);
static inline XCBGetWindowAttributesRep *XCBGetWindowAttributesReply(XCBConnection *c, XCBGetWindowAttributesCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("GetWindowAttributes");
    return (XCBGetWindowAttributesRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBGetGeometryRep *XCBGetGeometryReply(XCBConnection *c, XCBGetGeometryCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("GetGeometry");
    return (XCBGetGeometryRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline WINDOW *XCBQueryTreechildren(XCBQueryTreeRep *R)
{
    return (WINDOW *) (R + 1);
}

static inline int XCBQueryTreechildrenLength(XCBQueryTreeRep *R)
{
    return R->children_len;
}

static inline XCBQueryTreeRep *XCBQueryTreeReply(XCBConnection *c, XCBQueryTreeCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("QueryTree");
    return (XCBQueryTreeRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBInternAtomRep *XCBInternAtomReply(XCBConnection *c, XCBInternAtomCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("InternAtom");
    return (XCBInternAtomRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline CARD8 *XCBGetAtomNamename(XCBGetAtomNameRep *R)
{
    return (CARD8 *) (R + 1);
}

static inline int XCBGetAtomNamenameLength(XCBGetAtomNameRep *R)
{
    return R->name_len;
}

static inline XCBGetAtomNameRep *XCBGetAtomNameReply(XCBConnection *c, XCBGetAtomNameCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("GetAtomName");
    return (XCBGetAtomNameRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline void *XCBGetPropertyvalue(XCBGetPropertyRep *R)
{
    return (void *) (R + 1);
}

static inline int XCBGetPropertyvalueLength(XCBGetPropertyRep *R)
{
    return R->value_len * 8 / R->format;
}

static inline XCBGetPropertyRep *XCBGetPropertyReply(XCBConnection *c, XCBGetPropertyCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("GetProperty");
    return (XCBGetPropertyRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline ATOM *XCBListPropertiesatoms(XCBListPropertiesRep *R)
{
    return (ATOM *) (R + 1);
}

static inline int XCBListPropertiesatomsLength(XCBListPropertiesRep *R)
{
    return R->atoms_len;
}

static inline XCBListPropertiesRep *XCBListPropertiesReply(XCBConnection *c, XCBListPropertiesCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("ListProperties");
    return (XCBListPropertiesRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBGetSelectionOwnerRep *XCBGetSelectionOwnerReply(XCBConnection *c, XCBGetSelectionOwnerCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("GetSelectionOwner");
    return (XCBGetSelectionOwnerRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBGrabPointerRep *XCBGrabPointerReply(XCBConnection *c, XCBGrabPointerCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("GrabPointer");
    return (XCBGrabPointerRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBGrabKeyboardRep *XCBGrabKeyboardReply(XCBConnection *c, XCBGrabKeyboardCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("GrabKeyboard");
    return (XCBGrabKeyboardRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBQueryPointerRep *XCBQueryPointerReply(XCBConnection *c, XCBQueryPointerCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("QueryPointer");
    return (XCBQueryPointerRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline void TIMECOORDNext(TIMECOORDIter *i)
{
    TIMECOORD *R = i->data;
    --i->rem;
    i->data = (TIMECOORD *) (R + 1);
}

static inline TIMECOORD *XCBGetMotionEventsevents(XCBGetMotionEventsRep *R)
{
    return (TIMECOORD *) (R + 1);
}

static inline int XCBGetMotionEventseventsLength(XCBGetMotionEventsRep *R)
{
    return R->events_len;
}

static inline XCBGetMotionEventsRep *XCBGetMotionEventsReply(XCBConnection *c, XCBGetMotionEventsCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("GetMotionEvents");
    return (XCBGetMotionEventsRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBTranslateCoordinatesRep *XCBTranslateCoordinatesReply(XCBConnection *c, XCBTranslateCoordinatesCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("TranslateCoordinates");
    return (XCBTranslateCoordinatesRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBGetInputFocusRep *XCBGetInputFocusReply(XCBConnection *c, XCBGetInputFocusCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("GetInputFocus");
    return (XCBGetInputFocusRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBQueryKeymapRep *XCBQueryKeymapReply(XCBConnection *c, XCBQueryKeymapCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("QueryKeymap");
    return (XCBQueryKeymapRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline void FONTPROPNext(FONTPROPIter *i)
{
    FONTPROP *R = i->data;
    --i->rem;
    i->data = (FONTPROP *) (R + 1);
}

static inline void CHARINFONext(CHARINFOIter *i)
{
    CHARINFO *R = i->data;
    --i->rem;
    i->data = (CHARINFO *) (R + 1);
}

static inline FONTPROP *XCBQueryFontproperties(XCBQueryFontRep *R)
{
    return (FONTPROP *) (R + 1);
}

static inline int XCBQueryFontpropertiesLength(XCBQueryFontRep *R)
{
    return R->properties_len;
}

static inline CHARINFO *XCBQueryFontchar_infos(XCBQueryFontRep *R)
{
    return (CHARINFO *) (XCBQueryFontproperties(R) + (R->properties_len));
}

static inline int XCBQueryFontchar_infosLength(XCBQueryFontRep *R)
{
    return R->char_infos_len;
}

static inline XCBQueryFontRep *XCBQueryFontReply(XCBConnection *c, XCBQueryFontCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("QueryFont");
    return (XCBQueryFontRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBQueryTextExtentsRep *XCBQueryTextExtentsReply(XCBConnection *c, XCBQueryTextExtentsCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("QueryTextExtents");
    return (XCBQueryTextExtentsRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline char *STRname(STR *R)
{
    return (char *) (R + 1);
}

static inline int STRnameLength(STR *R)
{
    return R->name_len;
}

static inline void STRNext(STRIter *i)
{
    STR *R = i->data;
    --i->rem;
    i->data = (STR *) (STRname(R) + (R->name_len));
}

static inline XCBListFontsRep *XCBListFontsReply(XCBConnection *c, XCBListFontsCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("ListFonts");
    return (XCBListFontsRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBGetFontPathRep *XCBGetFontPathReply(XCBConnection *c, XCBGetFontPathCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("GetFontPath");
    return (XCBGetFontPathRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline void SEGMENTNext(SEGMENTIter *i)
{
    SEGMENT *R = i->data;
    --i->rem;
    i->data = (SEGMENT *) (R + 1);
}

static inline BYTE *XCBGetImagedata(XCBGetImageRep *R)
{
    return (BYTE *) (R + 1);
}

static inline int XCBGetImagedataLength(XCBGetImageRep *R)
{
    return R->length * 4;
}

static inline XCBGetImageRep *XCBGetImageReply(XCBConnection *c, XCBGetImageCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("GetImage");
    return (XCBGetImageRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline COLORMAP *XCBListInstalledColormapscmaps(XCBListInstalledColormapsRep *R)
{
    return (COLORMAP *) (R + 1);
}

static inline int XCBListInstalledColormapscmapsLength(XCBListInstalledColormapsRep *R)
{
    return R->cmaps_len;
}

static inline XCBListInstalledColormapsRep *XCBListInstalledColormapsReply(XCBConnection *c, XCBListInstalledColormapsCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("ListInstalledColormaps");
    return (XCBListInstalledColormapsRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBAllocColorRep *XCBAllocColorReply(XCBConnection *c, XCBAllocColorCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("AllocColor");
    return (XCBAllocColorRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBAllocNamedColorRep *XCBAllocNamedColorReply(XCBConnection *c, XCBAllocNamedColorCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("AllocNamedColor");
    return (XCBAllocNamedColorRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline CARD32 *XCBAllocColorCellspixels(XCBAllocColorCellsRep *R)
{
    return (CARD32 *) (R + 1);
}

static inline int XCBAllocColorCellspixelsLength(XCBAllocColorCellsRep *R)
{
    return R->pixels_len;
}

static inline CARD32 *XCBAllocColorCellsmasks(XCBAllocColorCellsRep *R)
{
    return (CARD32 *) (XCBAllocColorCellspixels(R) + (R->pixels_len));
}

static inline int XCBAllocColorCellsmasksLength(XCBAllocColorCellsRep *R)
{
    return R->masks_len;
}

static inline XCBAllocColorCellsRep *XCBAllocColorCellsReply(XCBConnection *c, XCBAllocColorCellsCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("AllocColorCells");
    return (XCBAllocColorCellsRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline CARD32 *XCBAllocColorPlanespixels(XCBAllocColorPlanesRep *R)
{
    return (CARD32 *) (R + 1);
}

static inline int XCBAllocColorPlanespixelsLength(XCBAllocColorPlanesRep *R)
{
    return R->pixels_len;
}

static inline XCBAllocColorPlanesRep *XCBAllocColorPlanesReply(XCBConnection *c, XCBAllocColorPlanesCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("AllocColorPlanes");
    return (XCBAllocColorPlanesRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline void COLORITEMNext(COLORITEMIter *i)
{
    COLORITEM *R = i->data;
    --i->rem;
    i->data = (COLORITEM *) (R + 1);
}

static inline void RGBNext(RGBIter *i)
{
    RGB *R = i->data;
    --i->rem;
    i->data = (RGB *) (R + 1);
}

static inline RGB *XCBQueryColorscolors(XCBQueryColorsRep *R)
{
    return (RGB *) (R + 1);
}

static inline int XCBQueryColorscolorsLength(XCBQueryColorsRep *R)
{
    return R->colors_len;
}

static inline XCBQueryColorsRep *XCBQueryColorsReply(XCBConnection *c, XCBQueryColorsCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("QueryColors");
    return (XCBQueryColorsRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBLookupColorRep *XCBLookupColorReply(XCBConnection *c, XCBLookupColorCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("LookupColor");
    return (XCBLookupColorRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBQueryBestSizeRep *XCBQueryBestSizeReply(XCBConnection *c, XCBQueryBestSizeCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("QueryBestSize");
    return (XCBQueryBestSizeRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBQueryExtensionRep *XCBQueryExtensionReply(XCBConnection *c, XCBQueryExtensionCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("QueryExtension");
    return (XCBQueryExtensionRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBListExtensionsRep *XCBListExtensionsReply(XCBConnection *c, XCBListExtensionsCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("ListExtensions");
    return (XCBListExtensionsRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline KEYSYM *XCBGetKeyboardMappingkeysyms(XCBGetKeyboardMappingRep *R)
{
    return (KEYSYM *) (R + 1);
}

static inline int XCBGetKeyboardMappingkeysymsLength(XCBGetKeyboardMappingRep *R)
{
    return R->length * 4;
}

static inline XCBGetKeyboardMappingRep *XCBGetKeyboardMappingReply(XCBConnection *c, XCBGetKeyboardMappingCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("GetKeyboardMapping");
    return (XCBGetKeyboardMappingRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBGetKeyboardControlRep *XCBGetKeyboardControlReply(XCBConnection *c, XCBGetKeyboardControlCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("GetKeyboardControl");
    return (XCBGetKeyboardControlRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBGetPointerControlRep *XCBGetPointerControlReply(XCBConnection *c, XCBGetPointerControlCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("GetPointerControl");
    return (XCBGetPointerControlRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBGetScreenSaverRep *XCBGetScreenSaverReply(XCBConnection *c, XCBGetScreenSaverCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("GetScreenSaver");
    return (XCBGetScreenSaverRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline BYTE *HOSTaddress(HOST *R)
{
    return (BYTE *) (R + 1);
}

static inline int HOSTaddressLength(HOST *R)
{
    return R->address_len;
}

static inline void HOSTNext(HOSTIter *i)
{
    HOST *R = i->data;
    --i->rem;
    i->data = (HOST *) (HOSTaddress(R) + (R->address_len));
}

static inline XCBListHostsRep *XCBListHostsReply(XCBConnection *c, XCBListHostsCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("ListHosts");
    return (XCBListHostsRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBSetPointerMappingRep *XCBSetPointerMappingReply(XCBConnection *c, XCBSetPointerMappingCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("SetPointerMapping");
    return (XCBSetPointerMappingRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline CARD8 *XCBGetPointerMappingmap(XCBGetPointerMappingRep *R)
{
    return (CARD8 *) (R + 1);
}

static inline int XCBGetPointerMappingmapLength(XCBGetPointerMappingRep *R)
{
    return R->map_len;
}

static inline XCBGetPointerMappingRep *XCBGetPointerMappingReply(XCBConnection *c, XCBGetPointerMappingCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("GetPointerMapping");
    return (XCBGetPointerMappingRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline XCBSetModifierMappingRep *XCBSetModifierMappingReply(XCBConnection *c, XCBSetModifierMappingCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("SetModifierMapping");
    return (XCBSetModifierMappingRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

static inline KEYCODE *XCBGetModifierMappingkeycodes(XCBGetModifierMappingRep *R)
{
    return (KEYCODE *) (R + 1);
}

static inline int XCBGetModifierMappingkeycodesLength(XCBGetModifierMappingRep *R)
{
    return R->keycodes_per_modifier * 8;
}

static inline XCBGetModifierMappingRep *XCBGetModifierMappingReply(XCBConnection *c, XCBGetModifierMappingCookie cookie, XCBGenericEvent **e)
{
    XCBREPTRACER("GetModifierMapping");
    return (XCBGetModifierMappingRep *) XCBWaitSeqnum(c, cookie.seqnum, e);
}

#endif
#include <X11/XCB/xcb_extension.h>
